SetupDibFormat proc uses ebx lpdib,dwWidth,dwHeight

mov ebx,lpdib
	assume ebx :ptr BITMAPINFOHEADER
	
		mov ecx,dwWidth					;set width for dib and
		shl ecx,1						;multiply width by two 
		mov [ebx].biWidth,ecx
		
		mov ecx,dwHeight					;set height for dib and
		shl ecx,1							;multiply by two
		not ecx							;NOT -> negative number 
		mov  [ebx].biHeight,ecx
		
		mov [ebx].biPlanes,1				;dib planes = 1
		mov [ebx].biBitCount,24			;set bpp of dib to 24
		mov [ebx].biCompression,BI_RGB	;no compression
		mov [ebx].biSize,\				;set the size of the
		SIZEOF BITMAPINFOHEADER					;bitmapinfoheader

	assume ebx:nothing
	ret
SetupDibFormat endp

CreateDib proc hDC,lpdib,lpPtrBits

	invoke CreateDIBSection,hDC,lpdib,\	;finally create the dib
			 DIB_RGB_COLORS, lpPtrBits,\
			 NULL,NULL
	ret
CreateDib endp
DrawDib proc hDestDC,dwX,dwY,ptrBits,lpbmi,dwBitsWidth,dwBitsHeight

	mov ebx,dwHeight												;mov height of rect into
	mov ecx,ebx													;ebx and ecx
	inc ebx														;increase ebx by one
	shl ecx,1														;multiply ecx by two
	;invoke the gdi function
	invoke SetDIBitsToDevice,hDestDC,0,0,dwX,dwY,dwBitsWidth,dwBitsHeight,ebx, NULL,ecx,ptrBits,addr bmi, DIB_RGB_COLORS
					 
	ret

DrawDib endp


